    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.awt.BorderLayout

    java.lang.Object
       |
       +----java.awt.BorderLayout

public class BorderLayout
extends Object
implements LayoutManager2, Serializable

A border layout lays out a container, arranging and resizing its components to fit in five regions: `North`, `South`, `East`, `West`, and `Center`. When adding a component to a container with a border layout, use one of these five names, for example:

        Panel p = new Panel();
        p.setLayout(new BorderLayout());
        p.add(new Button("Okay"), "South");

As a convenience, BorderLayout interprets the absence of a string specification the same as "Center":

        Panel p2 = new Panel();
        p2.setLayout(new BorderLayout());
        p2.add(new TextArea());  // Same as p.add(new TextArea(), "Center");

The components are laid out according to their preferred sizes and the constraints of the container's size. The `North` and `South` components may be stretched horizontally; the `East` and `West` components may be stretched vertically; the `Center` component may stretch both horizontally and vertically to fill any space left over.

Here is an example of five buttons in an applet laid out using the `BorderLayout` layout manager:

The code for this applet is as follows:

>      import java.awt.*;
>      import java.applet.Applet;
>      public class buttonDir extends Applet {
>        public void init() {
>          setLayout(new BorderLayout());
>          add("North",  new Button("North"));
>          add("South",  new Button("South"));
>          add("East",   new Button("East"));
>          add("West",   new Button("West"));
>          add("Center", new Button("Center"));
>        }
>      }

See Also:
  java.awt.Container.add

##

CENTER
  The center layout constraint (middle of container).
EAST
  The east layout constraint (left side of container).
NORTH
  The north layout constraint (top of container).
SOUTH
  The south layout constraint (bottom of container).
WEST
  The west layout constraint (right side of container).

##

BorderLayout()
  Constructs a new border layout with no gaps between components.
BorderLayout(int, int)
  Constructs a border layout with the specified gaps between components.

##

addLayoutComponent(Component, Object)
  Adds the specified component to the layout, using the specified constraint object.
addLayoutComponent(String, Component)
  Deprecated.
getHgap()
  Returns the horizontal gap between components.
getLayoutAlignmentX(Container)
  Returns the alignment along the x axis.
getLayoutAlignmentY(Container)
  Returns the alignment along the y axis.
getVgap()
  Returns the vertical gap between components.
invalidateLayout(Container)
  Invalidates the layout, indicating that if the layout manager has cached information it should be discarded.
layoutContainer(Container)
  Lays out the container argument using this border layout.
maximumLayoutSize(Container)
  Returns the maximum dimensions for this layout given the components in the specified target container.
minimumLayoutSize(Container)
  Determines the minimum size of the `target` container using this layout manager.
preferredLayoutSize(Container)
  Determines the preferred size of the `target` container using this layout manager, based on the components in the container.
removeLayoutComponent(Component)
  Removes the specified component from this border layout.
setHgap(int)
  Sets the horizontal gap between components.
setVgap(int)
  Sets the vertical gap between components.
toString()
  Returns a string representation of the state of this border layout.

##

NORTH

     public static final String NORTH

  The north layout constraint (top of container).

SOUTH

     public static final String SOUTH

  The south layout constraint (bottom of container).

EAST

     public static final String EAST

  The east layout constraint (left side of container).

WEST

     public static final String WEST

  The west layout constraint (right side of container).

CENTER

     public static final String CENTER

  The center layout constraint (middle of container).

##

BorderLayout

     public BorderLayout()

  Constructs a new border layout with no gaps between components.

BorderLayout

     public BorderLayout(int hgap,
                         int vgap)

  Constructs a border layout with the specified gaps between components. The horizontal gap is specified by `hgap` and the vertical gap is specified by `vgap`.

  Parameters:
    hgap - the horizontal gap.
    vgap - the vertical gap.

##

getHgap

     public int getHgap()

  Returns the horizontal gap between components.

setHgap

     public void setHgap(int hgap)

  Sets the horizontal gap between components.

  Parameters:
    hgap - the horizontal gap between components

getVgap

     public int getVgap()

  Returns the vertical gap between components.

setVgap

     public void setVgap(int vgap)

  Sets the vertical gap between components.

  Parameters:
    vgap - the vertical gap between components

addLayoutComponent

     public void addLayoutComponent(Component comp,
                                    Object constraints)

  Adds the specified component to the layout, using the specified constraint object. For border layouts, the constraint must be one of the following strings: `"North"`, `"South"`, `"East"`, `"West"`, or `"Center"`.

  Most applications do not call this method directly. This method is called when a component is added to a container using the `Container.add` method with the same argument types.

  Parameters:
    comp - the component to be added.
    constraints - an object that specifies how and where the component is added to the layout.
  Throws: IllegalArgumentException
    if the constraint object is not a string, or if it not one of the five specified strings.
  See Also:
    add

addLayoutComponent

     public void addLayoutComponent(String name,
                                    Component comp)

  Note: addLayoutComponent() is deprecated. replaced by `addLayoutComponent(Component, Object)`.

removeLayoutComponent

     public void removeLayoutComponent(Component comp)

  Removes the specified component from this border layout. This method is called when a container calls its `remove` or `removeAll` methods. Most applications do not call this method directly.

  Parameters:
    comp - the component to be removed.
  See Also:
    remove, removeAll

minimumLayoutSize

     public Dimension minimumLayoutSize(Container target)

  Determines the minimum size of the `target` container using this layout manager.

  This method is called when a container calls its `getMinimumSize` method. Most applications do not call this method directly.

  Parameters:
    target - the container in which to do the layout.
  Returns:
    the minimum dimensions needed to lay out the subcomponents of the specified container.
  See Also:
    Container, preferredLayoutSize, getMinimumSize

preferredLayoutSize

     public Dimension preferredLayoutSize(Container target)

  Determines the preferred size of the `target` container using this layout manager, based on the components in the container.

  Most applications do not call this method directly. This method is called when a container calls its `getPreferredSize` method.

  Parameters:
    target - the container in which to do the layout.
  Returns:
    the preferred dimensions to lay out the subcomponents of the specified container.
  See Also:
    Container, minimumLayoutSize, getPreferredSize

maximumLayoutSize

     public Dimension maximumLayoutSize(Container target)

  Returns the maximum dimensions for this layout given the components in the specified target container.

  Parameters:
    target - the component which needs to be laid out
  See Also:
    Container, minimumLayoutSize, preferredLayoutSize

getLayoutAlignmentX

     public float getLayoutAlignmentX(Container parent)

  Returns the alignment along the x axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.

getLayoutAlignmentY

     public float getLayoutAlignmentY(Container parent)

  Returns the alignment along the y axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.

invalidateLayout

     public void invalidateLayout(Container target)

  Invalidates the layout, indicating that if the layout manager has cached information it should be discarded.

layoutContainer

     public void layoutContainer(Container target)

  Lays out the container argument using this border layout.

  This method actually reshapes the components in the specified container in order to satisfy the constraints of this `BorderLayout` object. The `North` and `South`components, if any, are placed at the top and bottom of the container, respectively. The `West` and `East` components are then placed on the left and right, respectively. Finally, the `Center` object is placed in any remaining space in the middle.

  Most applications do not call this method directly. This method is called when a container calls its `doLayout` method.

  Parameters:
    target - the container in which to do the layout.
  See Also:
    Container, doLayout

toString

     public String toString()

  Returns a string representation of the state of this border layout.

  Returns:
    a string representation of this border layout.
  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.